#ifndef _H_D43366AF2540310E36AD56BBDBD45C6C_Packet_DCPS_H_
#define _H_D43366AF2540310E36AD56BBDBD45C6C_Packet_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Packet_.h"


namespace theora_image_transport
{
    namespace msg
    {
        namespace dds_
        {
            class Packet_TypeSupportInterface;

            typedef Packet_TypeSupportInterface * Packet_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Packet_TypeSupportInterface> Packet_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Packet_TypeSupportInterface> Packet_TypeSupportInterface_out;


            class Packet_DataWriter;

            typedef Packet_DataWriter * Packet_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Packet_DataWriter> Packet_DataWriter_var;
            typedef DDS_DCPSInterface_out < Packet_DataWriter> Packet_DataWriter_out;


            class Packet_DataReader;

            typedef Packet_DataReader * Packet_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Packet_DataReader> Packet_DataReader_var;
            typedef DDS_DCPSInterface_out < Packet_DataReader> Packet_DataReader_out;


            class Packet_DataReaderView;

            typedef Packet_DataReaderView * Packet_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Packet_DataReaderView> Packet_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Packet_DataReaderView> Packet_DataReaderView_out;

            struct Packet_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Packet_, struct Packet_Seq_uniq_> Packet_Seq;
            typedef DDS_DCPSSequence_var < Packet_Seq> Packet_Seq_var;
            typedef DDS_DCPSSequence_out < Packet_Seq> Packet_Seq_out;

            class  Packet_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Packet_TypeSupportInterface_ptr _ptr_type;
                typedef Packet_TypeSupportInterface_var _var_type;

                static Packet_TypeSupportInterface_ptr _duplicate (Packet_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Packet_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Packet_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Packet_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Packet_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Packet_TypeSupportInterface () {};
                ~Packet_TypeSupportInterface () {};
            private:
                Packet_TypeSupportInterface (const Packet_TypeSupportInterface &);
                Packet_TypeSupportInterface & operator = (const Packet_TypeSupportInterface &);
            };

            class  Packet_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Packet_DataWriter_ptr _ptr_type;
                typedef Packet_DataWriter_var _var_type;

                static Packet_DataWriter_ptr _duplicate (Packet_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Packet_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Packet_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Packet_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Packet_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Packet_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Packet_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Packet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Packet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Packet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Packet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Packet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Packet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Packet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Packet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Packet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Packet_& instance_data) = 0;

            protected:
                Packet_DataWriter () {};
                ~Packet_DataWriter () {};
            private:
                Packet_DataWriter (const Packet_DataWriter &);
                Packet_DataWriter & operator = (const Packet_DataWriter &);
            };

            class  Packet_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Packet_DataReader_ptr _ptr_type;
                typedef Packet_DataReader_var _var_type;

                static Packet_DataReader_ptr _duplicate (Packet_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Packet_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Packet_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Packet_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Packet_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Packet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Packet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Packet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Packet_& instance) = 0;

            protected:
                Packet_DataReader () {};
                ~Packet_DataReader () {};
            private:
                Packet_DataReader (const Packet_DataReader &);
                Packet_DataReader & operator = (const Packet_DataReader &);
            };

            class  Packet_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Packet_DataReaderView_ptr _ptr_type;
                typedef Packet_DataReaderView_var _var_type;

                static Packet_DataReaderView_ptr _duplicate (Packet_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Packet_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Packet_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Packet_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Packet_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Packet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Packet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Packet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Packet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Packet_& instance) = 0;

            protected:
                Packet_DataReaderView () {};
                ~Packet_DataReaderView () {};
            private:
                Packet_DataReaderView (const Packet_DataReaderView &);
                Packet_DataReaderView & operator = (const Packet_DataReaderView &);
            };
        }

    }

}

#endif
